﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HeuristicLab.Services.Hive.Common.DataTransfer;
using HeuristicLab.Services.Hive.Common.ServiceContracts;
using HeuristicLab.Clients.Hive.Slave.Tests;
using HeuristicLab.Clients.Hive;

namespace HeuristicLab.Services.Hive.Tests {
  [TestClass]
  public class ServerTest {

    [ClassInitialize]
    public static void MyClassInitialize(TestContext testContext) {
      PluginLoader.pluginAssemblies.Any();
      ServiceLocator.Instance = new MockServiceLocator(ServiceLocator.Instance);
    }
    
    private IHiveService GetService() {
      return new HiveService();
    }

    [TestMethod]
    public void TestMethod1() {
      var service = GetService();

      Job job = new Job() {
        CoresNeeded = 1,
        MemoryNeeded = 0,
        Priority = 0
      };

      JobData jobData = new JobData() {
        Data = PersistenceUtil.Serialize(new MockJob(500))
      };

      Guid jobId = service.AddJob(job, jobData);

      Job newJob = service.GetJob(jobId);
      Assert.AreEqual(job, newJob);
    }
  }
}
